<template>
  <div
    data-component-group="dropdown"
    data-component="teams"
  >
    <div class="component-header">
      <h1>
        {{ title }}
      </h1>
    </div>
    <div class="component-body">
      <Can
        I="view-all-threads"
        a="thread"
      >
        <v-autocomplete
          v-model="manager"
          :items="managers"
          prepend-inner-icon="account_circle"
          label="Manager"
          item-text="label"
          item-value="user.id"
          :return-object="true"
          required
          :menu-props="{nudgeBottom:'10'}"
          @change="onChangeManager"
        />
      </Can>

      <template
        v-if="$ability.can('view-all-threads', 'thread')
          || $ability.can('view-editors-threads', 'thread')"
      >
        <v-autocomplete
          v-model="editor"
          :items="editors"
          prepend-inner-icon="person"
          label="Editor"
          item-text="label"
          item-value="user.id"
          :return-object="true"
          required
          :menu-props="{nudgeBottom:'10'}"
          @change="onChangeEditor"
        />
      </template>

      <v-autocomplete
        v-model="unassignedType"
        :items="unassigned"
        prepend-inner-icon="perm_identity"
        label="Unassigned"
        item-text="label"
        item-value="id"
        :return-object="true"
        required
        :menu-props="{nudgeBottom:'10'}"
        @change="onChangeUnassigned"
      />
    </div>
  </div>
</template>

<script>
  import colors from 'vuetify/es5/util/colors';

  export default {
    props: {
      title: {
        type: String,
        default: 'Teams'
      },
      managers: {
        type: Array,
        required: true
      },
      editors: {
        type: Array,
        required: true
      },
      unassigned: {
        type: Array,
        required: true
      },
      disabled: {
        type: Boolean,
        default: false
      },
      onChangeItem: {
        type: Function,
        required: true
      }
    },
    data() {
      return {
        manager: {},
        editor: {},
        unassignedType: {},
        colors
      };
    },
    methods: {
      onChangeManager(manager) {
        this.editor = {};
        this.unassignedType = {};

        this.onChangeItem(manager, 'manager');
      },
      onChangeEditor(editor) {
        this.manager = {};
        this.unassignedType = {};

        this.onChangeItem(editor, 'editor');
      },
      onChangeUnassigned(unassigned) {
        this.manager = {};
        this.editor = {};

        this.onChangeItem(unassigned, 'unassigned');
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="dropdown"] {
    &[data-component="teams"] {
      padding: 0 0 20px 0;

      > .component-header {
        h1 {
          display: flex;
          align-items: center;
          margin: 0 0 20px 0;
        }
      }

      > .component-actions {
        &.has-filters {
          display: flex;
          justify-content: space-between;
          align-items: center;
        }

        .v-btn {
          margin: 0;

          .v-icon {
            margin: 0 6px 0 0;
          }

          border-radius: 4px;
        }
      }

      .v-text-field {
        padding-top: 6px;
      }
    }
  }
</style>
